SystemOrganization addCategory: #TusLibros!

Object subclass: #Cashier
	instanceVariableNames: 'purchaseBook'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cashier class methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 21:39'!
checkingOutAnEmptyCartErrorDescription
	^ 'No se puede realizar el cobro de un carrito vaco.'! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/3/2013 20:59'!
checkOut: aShoppingCart
	(aShoppingCart isEmpty) 
	ifTrue: [self error: self class checkingOutAnEmptyCartErrorDescription] 
	ifFalse: [ | totalValue | 
		totalValue := 0.
		purchaseBook add: totalValue ]! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/3/2013 20:48'!
initialize
	purchaseBook := OrderedCollection new.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/3/2013 20:45'!
purchaseCount
	^ purchaseBook size.! !

Object subclass: #ShoppingCart
	instanceVariableNames: 'catalog productsBag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!ShoppingCart class methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 20:45'!
addingAProductNotInCatalogErrorDescription
	^ 'No se puede agregar un producto que no exista en el catlogo'.! !

!ShoppingCart class methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 20:04'!
addingNonPositiveQuantityErrorDescription
	^ 'No se puede agregar al carrito una cantidad menor que 1'.! !

!ShoppingCart methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 21:17'!
addProduct: aProductID
	(catalog includesKey: aProductID) ifTrue: [productsBag add: aProductID] ifFalse: [self error: self class addingAProductNotInCatalogErrorDescription ].! !

!ShoppingCart methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 20:37'!
containsProduct: aProductID
	^ productsBag includes: aProductID "Association: (Association new key: aProductID value: aQuantity)."! !

!ShoppingCart methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/3/2013 21:12'!
getShoppingList
	"Devuelve la cantidad de items en el carrito"
	| aShoppingList |
	aShoppingList := Bag new.
	productsBag do: [ :aProduct | aShoppingList add: (Association new key: aProduct value: ( catalog at: aProduct )) ]
	! !

!ShoppingCart methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 20:55'!
initializeWithCatalog: aPublishersCatalog
	super initialize.
	productsBag := Bag new.
	catalog := aPublishersCatalog.! !

!ShoppingCart methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 21:39'!
isEmpty
	"Devuelve la cantidad de items en el carrito"
	^ productsBag isEmpty! !

!ShoppingCart methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 20:20'!
size
	"Devuelve la cantidad de items en el carrito"
	^ productsBag size! !

TestCase subclass: #TusLibrosTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TusLibrosTests methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/3/2013 20:55'!
aNonEmptyBookCatalog
	| aBookCatalog |
	aBookCatalog := Dictionary new.
	aBookCatalog add:  (Association new key: 1 value: 10.4).
	aBookCatalog add:  (Association new key: 2 value: 20.8).
	aBookCatalog add:  (Association new key: 3 value: 31.2).
	aBookCatalog add:  (Association new key: 4 value: 41.6).
	aBookCatalog add:  (Association new key: 5 value: 52.0).
	aBookCatalog add:  (Association new key: 6 value: 62.4).
	aBookCatalog add:  (Association new key: 7 value: 72.8).
	aBookCatalog add:  (Association new key: 8 value: 83.2).
	aBookCatalog add:  (Association new key: 9 value: 93.6).
	^ aBookCatalog! !

!TusLibrosTests methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/3/2013 20:56'!
aNonEmptyCart
	| aBookCart aBookCatalog |
	aBookCatalog := self aNonEmptyBookCatalog.
	aBookCart := ShoppingCart new initializeWithCatalog: aBookCatalog.
	aBookCart addProduct: 1.
	aBookCart addProduct: 3.
	aBookCart addProduct: 1.
	aBookCart addProduct: 5.
	aBookCart addProduct: 1.
	aBookCart addProduct: 7.
	^ aBookCart! !

!TusLibrosTests methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 21:09'!
anEmptyBookCart
	^ ShoppingCart new initializeWithCatalog: self anEmptyPublisherCatalog! !

!TusLibrosTests methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 21:14'!
anEmptyPublisherCatalog
	^ Dictionary new.! !

!TusLibrosTests methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 19:56'!
test01CartShouldBeEmptyAfterCreation
	"Luego de crear el carrito el mismo debe estar vaco"	
	self assert: self anEmptyBookCart size=0! !

!TusLibrosTests methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 21:20'!
test02AfterAddingABookCartMustHaveThatBook

	|aBookID aBookPrice aBookCart aBookCatalog|
	aBookID := 1.
	aBookPrice := 10.4.
	aBookCatalog := self anEmptyPublisherCatalog.
	aBookCatalog add:  (Association new key: aBookID value: aBookPrice).
	aBookCart := ShoppingCart new initializeWithCatalog: aBookCatalog.
	aBookCart addProduct: aBookID.
	self assert: (aBookCart containsProduct: aBookID).
	self assert: aBookCart size = 1.

	! !

!TusLibrosTests methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 21:55'!
test03AddingABookFromAnotherPublisherShouldRaiseAnException
	"No puedo agregar libros que no sean de mi editorial"
	|aBookID aBookCart |
	aBookID := 1.
	aBookCart := self anEmptyBookCart .
	self
		should: [ aBookCart addProduct: aBookID ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = ShoppingCart addingAProductNotInCatalogErrorDescription. 
			self assert: aBookCart isEmpty].
	! !

!TusLibrosTests methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/3/2013 20:48'!
test04CheckingOutAnEmptyCartShouldRaiseAnError	
	"No se puede cobrar un carrito vaco"
	| aCashier |
	aCashier := Cashier new.
	self
		should: [ aCashier checkOut: self anEmptyBookCart ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = Cashier checkingOutAnEmptyCartErrorDescription.
			self assert: aCashier purchaseCount = 0 ]! !

!TusLibrosTests methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/3/2013 20:56'!
test05CheckingOutANonEmptyCartShouldSaveTotalPrice
	"Al hacer checkout de un carrito con productos debo registrar en el libro de ventas el valor total de la venta"
	| aCashier |
	aCashier := Cashier new.
	aCashier checkOut: (self aNonEmptyCart).
	 ^ false! !
